//+------------------------------------------------------------------+ 
//|   _TRO_Multi_Meter_xRSI                                          | 
//|                                                                  | 
//|   Copyright  2007, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFT AND DONATIONS ACCEPTED                                    | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| go to www.kreslik.com for the latest indicator updates           |  
//+------------------------------------------------------------------+ 
//|                                                                  |
//| Use www.efxgroup.com as your forex broker...                     |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window

extern bool Show_Heading = false;
 
extern bool my.alert.sound     = true ; 
 
extern bool Corner_of_Chart_RIGHT_TOP = true;

extern int Shift_UP_DN =60; 
extern int Adjust_Side_to_side  = 20; // 20


extern string    IndName       = "RSI" ; // change

extern string    RSI_Settings  = "=== RSI Settings ===";
extern int       RSIPeriod     =  2;  // RSI  period 

extern int       RSIAlert1    = 50;  // RSI  period 
extern string    RSIAlert1Msg = " Alert" ;  // RSI  period 

extern color colorXup =  Lime ;
extern color colorXdn =  Crimson ;

extern double Level5 =  95 ;
extern double Level4 =  80 ;
extern double Level3 =  50 ;
extern double Level2 =  20 ;
extern double Level1 =  5 ;
extern double Level0 =  0 ;

extern color colorLevel5 =  Red ;
extern color colorLevel4 =  Orange ;
extern color colorLevel3 =  Yellow  ;
extern color colorLevel2 =  YellowGreen ;
extern color colorLevel1 =  Blue ;
extern color colorLevel0 =  DarkBlue;
 

extern color BarLabel_color     = LightBlue;
extern color CommentLabel_color = LightBlue;

//******************* 

bool use.pMid = false ;
//*******************

string ObjHead01,ObjHead02,ObjHead03,ObjHead04,ObjHead05,ObjHead06,ObjHead07,ObjHead08,ObjHead09,ObjHead10,ObjHead11;  

string Obj0001,Obj0002,Obj0003,Obj0004,Obj0005,Obj0006,Obj0007,Obj0008,Obj0009,Obj0010,Obj0011;  

int    MAMode;
string strMAType;
 
 
 

//+------------------------------------------------------------------+

color MeterColor( double rsimeter )
{
if( rsimeter > Level5 ) { return( colorLevel5 ); } 
if( rsimeter > Level4 ) { return( colorLevel4 ); } 
if( rsimeter > Level3 ) { return( colorLevel3 ); } 
if( rsimeter > Level2 ) { return( colorLevel2 ); } 
if( rsimeter > Level1 ) { return( colorLevel1 ); } 
return( colorLevel0 );  
} 
 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   

   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
   //***********************************************************************************************************************

string LabelTime="";

if (LabelTime=="") {LabelTime=TimeToStr(TimeLocal(),TIME_SECONDS); }

   int    counted_bars=IndicatorCounted();
   
string MAPeriod = " "+RSIPeriod   ;   

   ObjHead01 = "xRSIColHead01" + LabelTime  + MAPeriod ;  
   ObjHead02 = "xRSIColHead02" + LabelTime  + MAPeriod ;  
   ObjHead03 = "xRSIColHead03" + LabelTime  + MAPeriod ; 
   ObjHead04 = "xRSIColHead04" + LabelTime  + MAPeriod ;  
   ObjHead05 = "xRSIColHead05" + LabelTime  + MAPeriod ;  
   ObjHead06 = "xRSIColHead06" + LabelTime  + MAPeriod ; 
   ObjHead07 = "xRSIColHead07" + LabelTime  + MAPeriod ;  
   ObjHead08 = "xRSIColHead08" + LabelTime  + MAPeriod ;  
   ObjHead09 = "xRSIColHead09" + LabelTime  + MAPeriod ; 
         
   string xRSI_ObjHead01 ="M1 " ;
   string xRSI_ObjHead02 ="M5  " ;     
   string xRSI_ObjHead03 ="M15 " ;
   string xRSI_ObjHead04 =" M30 " ;
   string xRSI_ObjHead05 ="H1  " ;     
   string xRSI_ObjHead06 ="H4  " ;
   string xRSI_ObjHead07 ="D1  " ;
   string xRSI_ObjHead08 ="W1  " ;
   string xRSI_ObjHead09 ="MN1" ;   
   
   
        
    if (Corner_of_Chart_RIGHT_TOP == true)
    { int Col01x = 170+Adjust_Side_to_side ;                 
      int Col01y = 28+Shift_UP_DN ;
    }
    if (Corner_of_Chart_RIGHT_TOP == false)
   { Col01x = 159+Adjust_Side_to_side ;       
     Col01y = 24+Shift_UP_DN ;
    } 
    
   int ColAdj = -20 ; 
   int Col02x = Col01x + ColAdj ;   
   int Col03x = Col01x + ColAdj*2 ; 
   int Col04x = Col01x + ColAdj*3 ; 
   int Col05x = Col01x + ColAdj*4 ; 
   int Col06x = Col01x + ColAdj*5 ; 
   int Col07x = Col01x + ColAdj*6 ;    
   int Col08x = Col01x + ColAdj*7 ; 
   int Col09x = Col01x + ColAdj*8 ;     
   
   if ( Show_Heading) {        
   ObjectCreate(ObjHead01, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead01,xRSI_ObjHead01 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead01, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead01, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(ObjHead01, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead02, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead02,xRSI_ObjHead02 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead02, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead02, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(ObjHead02, OBJPROP_YDISTANCE, Col01y);   
       
   ObjectCreate(ObjHead03, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead03,xRSI_ObjHead03 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead03, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead03, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(ObjHead03, OBJPROP_YDISTANCE, Col01y); 
 
   ObjectCreate(ObjHead04, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead04,xRSI_ObjHead04 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead04, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead04, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(ObjHead04, OBJPROP_YDISTANCE, Col01y); 
   
   ObjectCreate(ObjHead05, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead05,xRSI_ObjHead05 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead05, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead05, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(ObjHead05, OBJPROP_YDISTANCE, Col01y); 
            
   ObjectCreate(ObjHead06, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead06,xRSI_ObjHead06 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead06, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead06, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(ObjHead06, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead07, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead07,xRSI_ObjHead07 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead07, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead07, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(ObjHead07, OBJPROP_YDISTANCE, Col01y); 
         
   ObjectCreate(ObjHead08, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead08,xRSI_ObjHead08 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead08, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead08, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(ObjHead08, OBJPROP_YDISTANCE, Col01y); 

   ObjectCreate(ObjHead09, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(ObjHead09,xRSI_ObjHead09 , 7, "Tahoma Narrow", BarLabel_color);
   ObjectSet(ObjHead09, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(ObjHead09, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(ObjHead09, OBJPROP_YDISTANCE, Col01y); 
       
} // Show_Heading

 //*******************   change for  your indicator ********************
 
    
    string M1_xRSI= "-",M5_xRSI= "-", M15_xRSI= "-", M30_xRSI= "-", H1_xRSI= "-", H4_xRSI= "-", D1_xRSI= "-",PRC1, W1_xRSI= "-", MN1_xRSI= "-";

    color  color_xRSIm1,color_xRSIm5,color_xRSIm15,color_xRSIm30,color_xRSIH1,color_xRSIH4,color_xRSID1,color_xRSIW1,color_xRSIMN1;     
         

   //xRSI Signals

string symbol = Symbol() ;

 color_xRSIm1  = ColorxRSI( symbol, PERIOD_M1  ) ;
 color_xRSIm5  = ColorxRSI( symbol, PERIOD_M5  ) ;
 color_xRSIm15 = ColorxRSI( symbol, PERIOD_M15 ) ;
 color_xRSIm30 = ColorxRSI( symbol, PERIOD_M30 ) ;
 color_xRSIH1  = ColorxRSI( symbol, PERIOD_H1  ) ;
 color_xRSIH4  = ColorxRSI( symbol, PERIOD_H4  ) ;
 color_xRSID1  = ColorxRSI( symbol, PERIOD_D1  ) ;
 color_xRSIW1  = ColorxRSI( symbol, PERIOD_W1  ) ;
 color_xRSIMN1 = ColorxRSI( symbol, PERIOD_MN1 ) ;

               
    
 //*******************          
    
    int Col00x = Col01x + 20 ;
    int Col00y = 50+Shift_UP_DN ;
    
    Col01y = 20+Shift_UP_DN ;
    
   Obj0002 = IndName+"SignalM1t" + LabelTime + MAPeriod ; 
           
           ObjectCreate(Obj0002, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0002,IndName+"("+MAPeriod+")", 7, "Tahoma Narrow",  BarLabel_color);  
   ObjectSet(Obj0002, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0002, OBJPROP_XDISTANCE, Col00x);
   ObjectSet(Obj0002, OBJPROP_YDISTANCE, Col00y);  // 50+Shift_UP_DN

   Obj0003 = IndName+"SignalM1" + LabelTime + MAPeriod ;        
           ObjectCreate(Obj0003, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0003, M1_xRSI, 40, "Tahoma Narrow",  color_xRSIm1);
   ObjectSet(Obj0003, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0003, OBJPROP_XDISTANCE, Col01x);
   ObjectSet(Obj0003, OBJPROP_YDISTANCE, Col01y); 

   Obj0004 = IndName+"SignalM5" + LabelTime + MAPeriod ;         
           ObjectCreate(Obj0004, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0004, M5_xRSI, 40, "Tahoma Narrow",  color_xRSIm5);
   ObjectSet(Obj0004, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0004, OBJPROP_XDISTANCE, Col02x);
   ObjectSet(Obj0004, OBJPROP_YDISTANCE, Col01y); 
      
   Obj0005 = IndName+"SignalM15" + LabelTime + MAPeriod ; 
   ObjectCreate(Obj0005, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0005, M15_xRSI, 40, "Tahoma Narrow",  color_xRSIm15);
   ObjectSet(Obj0005, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0005, OBJPROP_XDISTANCE, Col03x);
   ObjectSet(Obj0005, OBJPROP_YDISTANCE, Col01y); 
      
   Obj0006 = IndName+"SignalM30" + LabelTime + MAPeriod ;
   ObjectCreate(Obj0006, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0006, M30_xRSI, 40, "Tahoma Narrow",  color_xRSIm30);
   ObjectSet(Obj0006, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0006, OBJPROP_XDISTANCE, Col04x);
   ObjectSet(Obj0006, OBJPROP_YDISTANCE, Col01y); 

   Obj0007 = IndName+"SignalM60" + LabelTime + MAPeriod ;      
           ObjectCreate(Obj0007, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0007, H1_xRSI, 40, "Tahoma Narrow",  color_xRSIH1);
   ObjectSet(Obj0007, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0007, OBJPROP_XDISTANCE, Col05x);
   ObjectSet(Obj0007, OBJPROP_YDISTANCE, Col01y); 

   Obj0008 = IndName+"SignalM240" + LabelTime + MAPeriod ;          
           ObjectCreate(Obj0008, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0008, H4_xRSI, 40, "Tahoma Narrow",  color_xRSIH4);
   ObjectSet(Obj0008, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0008, OBJPROP_XDISTANCE, Col06x);
   ObjectSet(Obj0008, OBJPROP_YDISTANCE, Col01y);

   Obj0009 = IndName+"SignalM1440" + LabelTime + MAPeriod ;    
           ObjectCreate(Obj0009, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0009, D1_xRSI, 40, "Tahoma Narrow",  color_xRSID1);
   ObjectSet(Obj0009, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0009, OBJPROP_XDISTANCE, Col07x);
   ObjectSet(Obj0009, OBJPROP_YDISTANCE, Col01y);
   
   Obj0010 = IndName+"SignalW1" + LabelTime + MAPeriod ;    
           ObjectCreate(Obj0010, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0010, W1_xRSI, 40, "Tahoma Narrow",  color_xRSIW1);
   ObjectSet(Obj0010, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0010, OBJPROP_XDISTANCE, Col08x);
   ObjectSet(Obj0010, OBJPROP_YDISTANCE, Col01y);   
   
   Obj0011 = IndName+"SignalMN1" + LabelTime + MAPeriod ;    
           ObjectCreate(Obj0011, OBJ_LABEL, 0, 0, 0);
   ObjectSetText(Obj0011, MN1_xRSI, 40, "Tahoma Narrow",  color_xRSIMN1);
   ObjectSet(Obj0011, OBJPROP_CORNER, Corner_of_Chart_RIGHT_TOP);
   ObjectSet(Obj0011, OBJPROP_XDISTANCE, Col09x);
   ObjectSet(Obj0011, OBJPROP_YDISTANCE, Col01y); 
     
 //----

   return(0);
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----

ObjectsDeleteAll(0,OBJ_HLINE);
ObjectsDeleteAll(0,OBJ_TEXT);
ObjectsDeleteAll(0,OBJ_LABEL);
deleteObject(); 

//----
   return(0);
  }
  
void deleteObject()
  { 
//ObjectDelete(Obj0001);  
ObjectDelete(Obj0002); 
ObjectDelete(Obj0003); 
ObjectDelete(Obj0004); 
ObjectDelete(Obj0005); 
ObjectDelete(Obj0006); 
ObjectDelete(Obj0007); 
ObjectDelete(Obj0008); 
ObjectDelete(Obj0009); 
ObjectDelete(Obj0010); 
ObjectDelete(Obj0011); 

ObjectDelete(ObjHead01);  
ObjectDelete(ObjHead02); 
ObjectDelete(ObjHead03); 
ObjectDelete(ObjHead04); 
ObjectDelete(ObjHead05); 
ObjectDelete(ObjHead06); 
ObjectDelete(ObjHead07); 
ObjectDelete(ObjHead08); 
ObjectDelete(ObjHead09); 
 
  }
//+------------------------------------------------------------------+

color ColorxRSI( string myPair, int myPeriod   )  
{

color xRSI_color;

string xTF = TimeFrameToString(myPeriod) + " " ;

//      int BarShift = iBarShift(myPair,myPeriod,Time[0],true); 

double xRSI  = iRSI(myPair,myPeriod,RSIPeriod,PRICE_CLOSE,0);
double xRSI1 = iRSI(myPair,myPeriod,RSIPeriod,PRICE_CLOSE,1);  

xRSI_color = MeterColor(xRSI) ;

if( my.alert.sound ) {
    if( xRSI > RSIAlert1 &&  xRSI1 < RSIAlert1 ) { xRSI_color = colorXup ; Alert(xTF, "RSI(",RSIPeriod,") x UP "  ,RSIAlert1, RSIAlert1Msg  ) ; } else 
    if( xRSI < RSIAlert1 &&  xRSI1 > RSIAlert1 ) { xRSI_color = colorXdn ; Alert(xTF, "RSI(",RSIPeriod,") x DOWN " ,RSIAlert1, RSIAlert1Msg ) ; }
}

return( xRSI_color ) ;   
                                    
} // 

//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}